<template>
  <div id="open_space_wrapper" class="bt-container">
    <h1 class="page-title">{{ $t('OPENSPACE.TITLE') }} </h1>
	<div style="display:inline; float: right; margin-top:40px;">   
      <el-button size="small" @click="onClick('BACK')" :class="$attachReactablePostfix('el-btn')">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
    </div> 
		<div style="height: 100px;"/>
		
		<el-menu
		  mode="horizontal"
			:unique-opened="true"
			@select="selectCategory"
		  background-color="#4366ac"
		  text-color="#fff"
		  active-text-color="#ffd04b">
			<template v-for="(list, i) in openspace">
				<el-submenu :index="`${i}`" v-bind:key="i">
					<template slot="title"> {{ list.name }}</template>
							<el-menu-item v-for="(child, i2) in secondList" v-bind:key="i2" v-show="list.id === child.id_1st" :index="`${i + '-' + child.name}`">
								{{ child.name }}
							</el-menu-item>
				</el-submenu>
			</template>
		</el-menu>

		<div v-if="view === 1">
			<el-card class="box-card">
				<div slot="header" class="clearfix" style="text-align: right;">
					<el-button v-if="viewType" type="text" style="float: left; color: #000000" @click="selViewType(0)">기관으로 보기</el-button>
					<el-button v-else type="text" style="float: left; color: #000000" @click="selViewType(1)">맛보기로 보기</el-button>
					<el-radio-group v-model.number="showType" style="margin-bottom: 3px">							
					<!-- <el-radio-group>							 -->
						<el-radio-button :label="0">주제</el-radio-button>
						<el-radio-button :label="1">공지사항</el-radio-button>
						<el-radio-button :label="2">프로젝트</el-radio-button>
						<el-radio-button :label="3">구인</el-radio-button>
						<el-radio-button :label="4">구직</el-radio-button>
					</el-radio-group>
					<el-select v-model="searchQuery.searchType" style="display: inline-block; width: 100px">
						<el-option 
						v-for="option in selectOptionList"
						:key="option.value"
						:label="option.label"
						:value="option.value">
						</el-option>
					</el-select>
					<el-input style="display: inline-block; width: 300px" :placeholder="$t('STUDENT_MENU.ENT_SEARCH_TERM')"
										v-model="searchQuery.searchText" @keydown.enter.native="onClick('SEARCH', searchQuery)"></el-input>
					<el-button @click="onClick('SEARCH', searchQuery)" icon="el-icon-search" circle></el-button>
				</div>
				<!-- 맛보기로 보기 -->
				<div v-if="!viewType" >
					<open-space-table-subject
						v-if="showType === 0"
						v-model="affilList[0].subjectList"
						:height="heightSize"
					/>
					<!-- <div style="display: inline-flex; flex-wrap: wrap; justify-content: space-between; width: 100%"> -->
						<!-- [공지사항] 눌렸을 때 표시 -->
						<open-space-table-notify						
							v-if="showType === 1"
							v-model="affilList[0].notifyList"
							:height="heightSize"							
						/>
						<!-- [프로젝트] 눌렸을 때 표시 -->
						<open-space-table-project
							v-if="showType === 2"
							v-model="affilList[0].projectList"
							:height="heightSize"
						/>
					<!-- </div>
					<div style="display: inline-flex; flex-wrap: wrap; justify-content: space-between; width: 100%"> -->
						<!-- [구인] 눌렸을 때 표시 -->
						<open-space-table-gooin
							v-if="showType === 3"
							v-model="affilList[0].gooinList"
							:height="heightSize"
						/>
						<!-- [구직] 눌렸을 때 표시 -->
						<open-space-table-goozic
							v-if="showType === 4"
							v-model="affilList[0].goozicList"
							:height="heightSize"
						/>
					<!-- </div> -->
				</div>
				<!-- 기관으로 보기 -->
				<div v-else>
					<open-space-table-subject
						v-if="showType === 0"
						v-model="openList[0].subjectList"
						:height="heightSize"
					/>
					<!-- <div style="display: inline-flex; flex-wrap: wrap; justify-content: space-between; width: 100%"> -->
						<!-- [공지사항] 눌렸을 때 표시 -->
						<!-- <open-space-table-notify
							v-if="showType === 1"
							v-model="openList[0].notifyList"
							style="width: 48%;"
							:height="heightSize"
						/> -->
						<open-space-table-notify
							v-if="showType === 1"
							v-model="openList[0].notifyList"
							:height="heightSize"
						/>
						<!-- [프로젝트] 눌렸을 때 표시 -->
						<open-space-table-project
							v-if="showType === 2"
							v-model="openList[0].projectList"
							:height="heightSize"
						/>
					<!-- </div>
					<div style="display: inline-flex; flex-wrap: wrap; justify-content: space-between; width: 100%"> -->
						<!-- [구인] 눌렸을 때 표시 -->
						<open-space-table-gooin
							v-if="showType === 3"
							v-model="openList[0].gooinList"
							:height="heightSize"
						/>
						<!-- [구직] 눌렸을 때 표시 -->
						<open-space-table-goozic
							v-if="showType === 4"
							v-model="openList[0].goozicList"
							:height="heightSize"
						/>
					<!-- </div> -->
				</div>
			</el-card>
		</div>
		<div v-else>
			<open-space-preswot
				v-model="preswotNotifyList"
				:height="heightSize"
			/>
		</div>
  </div>
</template>

<script>
import deepCopy from "deep-copy";
import openspaceService from '../../services/openspaceService';
import OpenSpacePreswot from '../partials/OpenSpacePreswot'
import OpenSpaceTableSubject from '../partials/OpenSpaceTableSubject'
import OpenSpaceTableNotify from '../partials/OpenSpaceTableNotify';
import OpenSpaceTableProject from '../partials/OpenSpaceTableProject';
import OpenSpaceTableGooin from '../partials/OpenSpaceTableGooin';
import OpenSpaceTableGoozic from '../partials/OpenSpaceTableGoozic';
import utils from '../../utils'; 

export default {
  name: 'OpenSpace',
  async created() {
		const vm = this;

		let res = await openspaceService.get1stCategories();
		vm.openspace = res.data;
		res = await openspaceService.get2ndCategories();
		vm.secondList = res.data;
		res = await openspaceService.getPreswotNotifyList();
		vm.preswotNotifyList = res.data.result[0];

		// 2021-05-11 Follow중인 기관ID 리스트 조회
		res = await openspaceService.getOpenAffiliationFollowList({
			id: utils.getUserIdFromJwt(),
		});
		vm.followingList = res.data.result;

		// height 정의
		vm.heightSize = (window.innerHeight || document.body.clientHeight) * 0.4;

		vm.affilList = deepCopy(vm.openList);
	},
	components: {
		OpenSpacePreswot,		// 프리스왓 default (preswot에서 등록한것)
		OpenSpaceTableSubject,	// 맛보기
		OpenSpaceTableNotify,	// 공지사항
		OpenSpaceTableProject,	// 프로젝트
		OpenSpaceTableGooin,	// 구인
		OpenSpaceTableGoozic	// 구직
	},
  data() {
    return {
			openspace: [],
			preswotNotifyList: [],
			openList: [{
				subjectList: [],
				notifyList: [],
				projectList: [],
				gooinList: [],
				goozicList: [],
			}],
			affilList: [],
			view: 0,
			secondList: [],
			selectOptionList: [
				{
				value: 'affiliation',
				label: this.$t('OPENSPACE.AFFILIATION'),
				},
			],
			searchQuery: {
				searchType: 'affiliation',
				searchText: '',
			},
			heightSize: 0,
			viewType: 0,
			showType: 0,			// 주제: 0, 공지사항: 1, 프로젝트: 2, 구인: 3, 구직: 4
			followingList: [], 		// 현재 Follow 중인 기관의 ID 리스트
    		};
	},
  methods: {
    async onClick(type, arg) {
      const vm = this;
      switch (type) {
        case 'BACK': {
          location.href = "javascript:history.back();";
          break;          
				}
				case 'SEARCH': {
					const vm = this;
					if (vm.searchQuery.searchText==='') return
					// 클릭 로그 (검색 로그)
					const res = await openspaceService.getSearchAffiliation({
						name: vm.searchQuery.searchText
					});
					if (res.data.result.length !== 0) {
						vm.addListInfo(res);
					} else {
						vm.$notify({
	            title: '오류',
  	          message: '검색한 기관이 없습니다.',
							type: 'warning',
							duration: 1000,
      	    });
					}
          break;
				}
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
		},
		selViewType(type) {
			const vm = this;
			vm.viewType = type;
		},
		async selectCategory(key, keyPath) {
			const vm = this;
			key = key.split('-');
			const res = await openspaceService.get2ndCategoriesById({
				id_1st: parseInt(key[0], 10) + 1,
				name: key[1],
			});
			vm.addListInfo(res, 'open');
			const res2 = await openspaceService.getOpenAffiliationById({
				id: key[1],
			});
			vm.addListInfo(res2, 'affil');
			vm.view = 1;
		},
		addListInfo(list, type) {
			const vm = this;
			if (type === 'open') {
				vm.openList[0].subjectList = [];
				vm.openList[0].notifyList = [];
				vm.openList[0].projectList = [];
				vm.openList[0].gooinList = [];
				vm.openList[0].goozicList = [];

				console.log(vm.followingList);

				list.data.result.forEach((x) => {					
					
					x.forEach((y) => {						
						y.isFollow = 0;
						
						vm.followingList.some(function(id) {					
							return (id.affiliation_id === y.affiliation_id ? y.isFollow = 1 : y.isFollow = 0)
						});
						if (y.affiliation_description.isOpen === 7) {							
							vm.openList[0].subjectList.push(y);
						} else if (y.affiliation_description.isOpen === 3) {
							vm.openList[0].notifyList.push(y);
						} else if (y.affiliation_description.isOpen === 4) {
							vm.openList[0].projectList.push(y);
						} else if (y.affiliation_description.isOpen === 5) {
							vm.openList[0].gooinList.push(y);
						} else if (y.affiliation_description.isOpen === 6) {
							vm.openList[0].goozicList.push(y);
						}
					});
				});
			} else if (type === 'affil') {
				vm.affilList[0].subjectList = [];
				vm.affilList[0].notifyList = [];
				vm.affilList[0].projectList = [];
				vm.affilList[0].gooinList = [];
				vm.affilList[0].goozicList = [];
				list.data.result.forEach((x) => {
					const tmp = x.class.isOpenSpace.split('/');
					x.isFollow = 0;

					vm.followingList.some(function(id) {					
						return (id.affiliation_id === x.affiliation_id ? x.isFollow = 1 : x.isFollow = 0)
					});

					if (tmp[1] === '맛보기') {
						vm.affilList[0].subjectList.push(x);
					} else if (tmp[1] === '공지사항') {
						vm.affilList[0].notifyList.push(x);
					} else if (tmp[1] === '프로젝트') {
						vm.affilList[0].projectList.push(x);
					} else if (tmp[1] === '구인') {
						vm.affilList[0].gooinList.push(x);
					} else if (tmp[1] === '구직') {
						vm.affilList[0].goozicList.push(x);
					}
				});
			}
		},
  },
};
</script>         

<style lang="scss" scoped>
#open_space_wrapper {
  .page-title {
    float:left;
    height: 24px;

    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top : 40px;
    margin-left : 12px;
    margin-bottom : 25px;
  }
  .box-card {
    width: 100%;
    overflow-y: auto;
  }
  .button {
    $text-color: #000000;
    $hover-color: #ffffff;    
  }
	.hotSubject{
		margin: 5px 50px 10px 50px
	}
	.hotInstitution{
		margin: 5px 50px 10px 50px
	}
}

</style>
